dot/bashrc: Pass login flag to `rc' by default.
[profile] / setup
... / ...
CommitLineData
1#! /bin/bash
2
3set -e
4
5###--------------------------------------------------------------------------
6### Basic setup.
7
8umask 002
9
10sub=
11mkdir -p $HOME$sub
12
13: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17###--------------------------------------------------------------------------
18### Sort out command line.
19
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
36here=$(pwd)
37
38## Suss out how to print things
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
48## Find out how to fetch things over the net
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
80echo "Installing packages..."
81systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84"
85[ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
116echo " all done."
117
118###--------------------------------------------------------------------------
119### Install global configuration.
120
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
129## Symlink the various dotfiles into place
130dotfiles="
131 bash_profile bash_logout bashrc inputrc bash_completion
132 emacs emacs-calc vm gnus.el
133 vimrc mg zile
134 mailrc signature
135 cgrc tigrc
136 gdbinit
137 guile
138 rcrc
139 toprc
140 aspell.conf
141 lisp-init.lisp:.cmucl-init.lisp
142 lisp-init.lisp:.sbclrc
143 lisp-init.lisp:.clisprc.lisp
144 lisp-init.lisp:.eclrc
145 swank.lisp
146 dircolors colordiffrc screenrc cvsrc indent.pro"
147[ "$xstuff" ] && dotfiles="$dotfiles
148 xinitrc xsession Xdefaults vncrc vncsession
149 fonts.conf
150 stalonetrayrc
151 putty-defaults:.putty/sessions/Default%20Settings
152 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
153 e-keybindings.cfg:.enlightenment/keybindings.cfg
154 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
155 e16-bindings:.e16/bindings.cfg"
156echo "Installing dotfiles..."
157for d in $dotfiles; do
158 target=.$d
159 case $d in
160 *:*) target=${d#*:} d=${d%%:*};;
161 esac
162 ft=$HOME$sub/$target
163 dir=${ft%/*}
164 mkdir -p $dir
165 ln -s $here/dot/$d $ft.new
166 mv $ft.new $ft
167 echo " $target"
168done
169echo " all done."
170
171## Substitute things which need substituting.
172dotfilessubst="
173 gitconfig
174 pulse-default.pa.in:.pulse/default.pa"
175echo "Installing dotfiles with substitutions..."
176for d in $dotfilessubst; do
177 case $d in
178 *:*) target=${d#*:} d=${d%%:*};;
179 *) target=.$d d=$d.in;;
180 esac
181 ft=$HOME$sub/$target
182 dir=${ft%/*}
183 mkdir -p $dir
184 sed "
1851i\
186### generated by $here/setup; do not edit!\
187
188/@home@/ s\a\a$HOME\ag
189/@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
190/@gitignore@/ s\a\a$(bin/mdw-conf gitignore $here/git/gitignore)\ag
191" dot/$d >$ft.new
192 mv $ft.new $ft
193 echo " $target"
194done
195echo " all done."
196
197## Symlink backgrounds.
198backgrounds="
199 jue-peek.jpg
200 medusa.jpg
201 bsg-supper.jpg
202 rayne.jpg
203 hypatia.jpg
204 noodly.jpg
205 lovelace.jpg"
206if [ "$xstuff" ]; then
207 echo "Installing backgrounds..."
208 for b in $backgrounds; do
209 for e in enlightenment e16; do
210 dir=$HOME$sub/.$e/backgrounds
211 t=$dir/$b
212 mkdir -p $dir
213 ln -s $here/bg/$b $t.new
214 mv $t.new $t
215 done
216 echo " $b"
217 done
218 echo " all done."
219fi
220
221###--------------------------------------------------------------------------
222### Install useful scripts included in this package.
223
224scripts="
225 mdw-editor
226 mdw-pager
227 mdw-conf
228 mdw-build
229 emacsclient-hack
230 movemail-hack
231 aspell-hack
232 emerge-hack
233 lesspipe.sh
234 start-ssh-agent
235 svnwrap
236 hyperspec"
237[ "$xstuff" ] && scripts="$scripts
238 xinitcmd
239 un-backslashify-selection
240 lock-screen
241 xshutdown"
242echo "Installing scripts..."
243mkdir -p $HOME$sub/bin
244for s in $scripts; do
245 ft=$HOME$sub/bin/$s
246 ln -s $here/bin/$s $ft.new
247 mv $ft.new $ft
248 echo " $s"
249done
250echo " all done."
251
252###--------------------------------------------------------------------------
253### Set up the Emacs config.
254
255$echon "Finding a suitable emacs:$echoc"
256emacs=no
257for i in emacs22 emacs23 emacs21 emacs; do
258 if type -p >/dev/null $i; then
259 emacs=$i
260 break
261 fi
262done
263if [ $emacs = no ]; then
264 echo " failed."
265 emacs=:
266else
267 echo " $emacs."
268fi
269
270echo "Installing Emacs packages..."
271emacspkg="
272 make-regexp
273 ew-hols
274 mdw-gnus-patch
275 git git-blame vc-git stgit
276 quilt"
277for elib in $emacspkg; do
278 $echon " $elib:$echoc"
279 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
280 (progn
281 (setq load-path (nconc load-path (list "~/lib/emacs")))
282 (kill-emacs (condition-case nil
283 (progn (load-library "'"$elib"'") 0)
284 (error 1))))'; then
285 echo " already installed."
286 else
287 if [ -f el/$elib.el ]; then
288 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
289 else
290 $echon " downloading$echoc"
291 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
292 fi
293 $echon " compiling$echoc"
294 (cd $HOME$sub/lib/emacs;
295 $emacs >/dev/null 2>&1 --no-site-file --batch \
296 --eval '(byte-compile-file "'"$elib.el"'")')
297 echo " done."
298 fi
299done
300echo " all done."
301
302$echon "Setting up Emacs configuration:$echoc"
303$echon " linking$echoc"
304for f in dot-emacs.el Makefile; do
305 set -- $(echo $link | tr : ' ')
306 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
307 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
308done
309$echon " compiling$echoc"
310make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
311echo " done."
312
313###----- That's all, folks --------------------------------------------------